﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Class MainWindow
    Implements INotifyPropertyChanged


    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        AllPersons = New ObservableCollection(Of Person)
        AllPersons.Add(New Person("Max", "Mustermann"))
        AllPersons.Add(New Person("Susi", "Sorglos", PersonGender.Female))
        AllPersons.Add(New Person("Maria", "Musterfrau", PersonGender.Female))
        AllPersons.Add(New Person("Peter", "Hilflos"))

        Me.DataContext = Me

        Dim colView As CollectionViewSource = CType(Me.FindResource("personsView"), CollectionViewSource)
        colView.SortDescriptions.Clear()
        colView.SortDescriptions.Add(New SortDescription("FirstName", ListSortDirection.Ascending))
    End Sub

    Private _allPersons As ObservableCollection(Of Person)

    Public Property AllPersons() As ObservableCollection(Of Person)
        Get
            Return _allPersons
        End Get
        Set(ByVal value As ObservableCollection(Of Person))
            _allPersons = value
            RaisePropertyChanged()
        End Set
    End Property

    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class
